//////////////////////////////////////////////////////////////////////
// scene.cpp: implementation of the scene class.
//
//////////////////////////////////////////////////////////////////////
#include "scene.h"
//////////////////////////////////////////////////////////////////////
// Tu je vsetko co sa kresli

void scene::DrawGLScene()
{
	if(keys['L'] && keys[VK_CONTROL]){ english = !english; keys['L']=0; }
	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);	//cisti buffer v aktualnom viewporte a to iba color a hlbkovy bit
	Prepni_do_3D();
	glLoadIdentity();
	GetCursorPos(&MouseBod);
	mouse_x = MouseBod.x;
	mouse_y = screen_y-1-MouseBod.y;
	
	c->MoveWorld(fps);
	if(kolizia)obj_dxf->CheckCollision(&c->vp,polomer_gule);
	c->d();

	if(keys[VK_ADD]) polomer_gule += 0.1f/fps;
	else if(keys[VK_SUBTRACT]) polomer_gule -= 0.1f/fps;

	if(keys['L']){	svetlo = !svetlo; keys['L']=0; }
	if(keys['K']){	kolizia = !kolizia; keys['K']=0; }
	if(svetlo)glEnable(GL_LIGHTING);
	if(keys['P'])	{	ciary = !ciary;keys['P']=0;	}
	if(keys['N'])	{	normals = !normals;keys['N']=0;	}	
	{
		GLfloat LightPosition[4]=	{ 0.0f, 0.0f, 1.0f, 1.0f };		//smer difuzneho svetla - ak je 4 zlozka 0 - smerove svetlo, ak nie je 0 potom s jedna o bodove svetlo so suradnicami x,y,z

		LightPosition[0]=c->vp.x;
		LightPosition[1]=c->vp.y;
		LightPosition[2]=c->vp.z;
	
		glLightfv ( GL_LIGHT0, GL_POSITION, LightPosition  );		// pozicia difuzneho svetla
	}
//	glRotatef(-90,1,0,0);
//	glScalef(0.005f,0.005f,0.005f);

//	if(ciary)obj->Render_line();
//	else obj->Render();

//	glBindTexture(GL_TEXTURE_2D,textura);
	if(ciary)obj_dxf->Render_line();
	//	obj_dxf->Render_visible_line(c->vp.x,c->vp.y,c->vp.z);
	else obj_dxf->Render();
	
	glDisable(GL_LIGHTING);					// vypnutie osvetlenia

	if(normals)obj_dxf->Render_normals();

	glColor4f(1,1,1,1);
	glLoadIdentity();
	glDisable(GL_TEXTURE_2D);
	Kurzor();
	glEnable(GL_TEXTURE_2D);
	
	font0->Begin();
	fps = 1.0f / timer0.GetTime();
	timer0.Reset();
	fps_counter.GetAvgFps(1.f/fps,0.2f);
	gcvt( (double)fps_counter.avg_fps, 4, text);
	font0->Print(0,0,text,0);

	gcvt( (double)polomer_gule, 4, text);
	font0->Print(0,1,text,0);
	if(kolizia)font0->Print(63,0,english ? "collision" : "kolizia",0);

	if(keys['H'])							// zobrazenie helpu
	{
		int i=3;
		glDisable(GL_TEXTURE_2D);
		glBlendFunc(GL_SRC_ALPHA,GL_ONE_MINUS_SRC_ALPHA);
		glColor4f(0,0,0,0.7f);
		glLoadIdentity();
		glBegin(GL_QUADS);
			glVertex2i(0,360);
			glVertex2i(800,360);
			glVertex2i(800,555);
			glVertex2i(0,555);
		glEnd();
		glColor4f(1,1,1,1);
		glBlendFunc(GL_SRC_ALPHA,GL_ONE_MINUS_SRC_COLOR);
		glEnable(GL_TEXTURE_2D);

		if(english)
		{
			font0->Print(15,i++,"Program: Collision",0);
			glColor3f(0.9f,0.9f,1.0f);
			font0->Print(8,i++,"Pogrammer: Marek Mizanin - www.mizanin.szm.sk",0);
			glColor3f(1.0f,1.0f,1.0f);
			font0->Print(10,i++,"Controls:",0);
			font0->Print(2,i++,"K - on/off collision detection",1);
			font0->Print(2,i++,"+ and - on numeric. - increase and decrease radius of sphere",1);
			font0->Print(2,i++,"2. row - radius of sphere to collision calculation",1);
			font0->Print(2,i++,"P - on/off wire frame",1);
			font0->Print(2,i++,"L - on/off lighting",1);
			font0->Print(2,i++,"N - on/off show normal vectors",1);
			font0->Print(2,i++,"R - reset camera",1);

		}
		else
		{
			font0->Print(15,i++,"Program: Kolizia",0);
			glColor3f(0.9f,0.9f,1.0f);
			font0->Print(8,i++,"Naprogramoval: Marek Mizanin - www.mizanin.szm.sk",0);
			glColor3f(1.0f,1.0f,1.0f);
			font0->Print(10,i++,"Pouzivane klavesy:",0);
			font0->Print(2,i++,"K - zapne/vypne detekciu kolizie",1);
			font0->Print(2,i++,"+ a - na numer. klav. - zvacsovanie a zmensovanie polomeru gule",1);
			font0->Print(2,i++,"2. riadok - polomer gule s ktorou sa pocita kolizia",1);
			font0->Print(2,i++,"P - zapne/vypne zobrazovanie ciar",1);
			font0->Print(2,i++,"L - zapne/vypne scetlo",1);
			font0->Print(2,i++,"N - zapne/vypne zobrazovanie normalovych vektorov",1);
			font0->Print(2,i++,"R - reset kamery",1);
		}

		font0->Print(2,i++,"H - help",1);
	}
	font0->End();
}