// dxf.cpp: implementation of the dxf class.
//
//////////////////////////////////////////////////////////////////////

#include "dxf.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

dxf::dxf()
{
	error = 1;
}

dxf::dxf(char *file_name)
{
	sub=NULL;

	for(int i=0; i<MAX_LEVEL; i++)
	{
		ZeroMemory( &level[i],sizeof(Slevel) );
	}
	sub = fopen(file_name,"r");
	if(sub == NULL){ error = 1; return;}
	
	Int();
	String();		// nacitanie textu
	if(error)return;

	if(strcmp(t,"SECTION") || c!=0)
	{
		MessageBox(NULL,"Chybny zaciatok suboru","Chyba",MB_OK); 
		error=1; 
		fclose(sub);
		return;
	}

	while(1)
	{
		while(strcmp(t,"3DFACE"))
		{
			String();		// nacitanie textu
			if(error||!strcmp(t,"EOF"))	break;
		}
		if(error||!strcmp(t,"EOF")) break;
		// sme v 3DFACE
		LoadFace();
		if(error)return;
	}
	fclose(sub);

	for(i=0; i<MAX_LEVEL; i++)		// zez vsetky levely
	{
		if(level[i].texturing)				// ak je v levely textura
		{
			for(int j=0; j<strlen(level[i].name); j++)	// nahradenie '_' '.'
			{
				if(level[i].name[j]=='_') level[i].name[j]='.';
			}
			if( !LoadTexture(level[i].name, &level[i].texture))
			{
				level[i].texturing=0;
				level[i].color[0] = 1.0f;
				level[i].color[1] = 1.0f;
				level[i].color[2] = 1.0f;
				level[i].color[3] = 1.0f;
				MessageBox(NULL,"Nenajdena textura",level[i].name,MB_OK);
			//	error=1;
			}
		}
	}
}

dxf::~dxf()
{
	for(int i=0; i<MAX_LEVEL; i++)
	{
		if(level[i].texturing)	glDeleteTextures( 1, &level[i].texture);
	}
}

void dxf::String()
{
	
	if( fgets( t, 100, sub ) == NULL) 
	{
		MessageBox(NULL,"Predcasny koniec suboru.","Chyba",MB_OK); 
		error=1; 
		fclose(sub);
		return;
	}
	{
		char pom[100];
		int r,s=0,l;
		
		l = strlen(t);
		for(r=0; r<l+1; r++)		// vratane 0
		{
			if(t[r]!='\n' && t[r]!=' ') 
				pom[s++] = t[r];
		}
		l = strlen(pom);
		for(r=0; r<l+1; r++) t[r] = pom[r];
	}
}

void dxf::Int()
{
	char s[10];

	if( fgets( s, 10, sub ) == NULL) 
	{
		MessageBox(NULL,"Predcasny koniec suboru.","Chyba",MB_OK); 
		error=1; 
		fclose(sub);
		return;
	}
	c = atoi(s);
}

float dxf::Float()
{
	char s[30];

	if( fgets( s, 30, sub ) == NULL) 
	{
		MessageBox(NULL,"Predcasny koniec suboru.","Chyba",MB_OK); 
		error=1; 
		fclose(sub);
		return 0.0f;
	}
	return atof(s);
}

void dxf::LoadFace()
{
	int lev=-1;
	face4	f;

	while(strcmp(t,"10") && strcmp(t,"8"))
	{
		String();		// nacitanie textu
		if(error)return;
	}

	if(!strcmp(t,"8"))						// je meno levelu
	{
		String();
		for(int i=0; i<MAX_LEVEL; i++)		// zez vsetky levely
		{
			if(level[i].texturing)				// ak je v levely textura
			{
				if(!strcmp(t,level[i].name))	// ak sa jej meno zhoduje
				{
					lev = i;				// pouzijeme tento level
					i = MAX_LEVEL;
				}
			}
		}
		if(lev<0) lev = -2;
	}

	if(lev==-2)								// musime pouzit novy level
	{
		for(int i=0; i<MAX_LEVEL; i++)
		{
			if(level[i].num_face==0)			// hladame prazny level
			{
				lev = i;
				i=MAX_LEVEL;				// ukoncime prehladavanie
				// nastavime meno textury
				strcpy(level[lev].name,t);
				level[lev].texturing=1;
			}
		}
	}

	if(lev==-1)								// pouzijeme prvy level bez textury
	{
		for(int i=0; i<MAX_LEVEL; i++)
		{
			if(!level[i].texturing)			// vyhladavame level bez textury
			{
				lev = i;
				i=MAX_LEVEL;				// ukoncime prehladavanie
			}
		}
	}

	if(lev<0)
	{
		MessageBox(NULL,"Nie je miesto pre dalsie levely","ERROR",MB_OK);
		fclose(sub);
		error=1;
		return;
	}

	while(strcmp(t,"10"))
	{
		String();		// nacitanie textu
		if(error)return;
	}

	f.v[0].x = Float();	// 10
	if(error)return;
	String(); if(error)return;
	f.v[0].y = Float();	// 20
	if(error)return;
	String(); if(error)return;
	f.v[0].z = Float();	// 30
	if(error)return;
	
	for(int i=1; i<4; i++)
	{
		String(); if(error)return;
		f.v[i].x = Float();	// 1i
		if(error)return;
		String(); if(error)return;
		f.v[i].y = Float();	// 2i
		if(error)return;
		String(); if(error)return;
		f.v[i].z = Float();	// 3i
		if(error)return;
	}
	// otocenie take ako glRotatef(-90,1,0,0);
	{
		float z;
		z = f.v[0].y;
		f.v[0].y = f.v[0].z;
		f.v[0].z = -z;

		z = f.v[1].y;
		f.v[1].y = f.v[1].z;
		f.v[1].z = -z;

		z = f.v[2].y;
		f.v[2].y = f.v[2].z;
		f.v[2].z = -z;

		z = f.v[3].y;
		f.v[3].y = f.v[3].z;
		f.v[3].z = -z;
	}

	{	// vypocet normaloveho vektora
		XYZ		p1,p2;
		float length;

		p1.x = f.v[1].x - f.v[0].x;
		p1.y = f.v[1].y - f.v[0].y;
		p1.z = f.v[1].z - f.v[0].z;

		p2.x = f.v[2].x - f.v[1].x;
		p2.y = f.v[2].y - f.v[1].y;
		p2.z = f.v[2].z - f.v[1].z;

		f.n.x = p1.y*p2.z - p1.z*p2.y;
		f.n.y = p1.z*p2.x - p1.x*p2.z;
		f.n.z = p1.x*p2.y - p1.y*p2.x;
	
		length = (float) sqrt(f.n.x * f.n.x + f.n.y * f.n.y + f.n.z * f.n.z);
		if (length != 0) {
			f.n.x /= length;
			f.n.y /= length;
			f.n.z /= length;
		} else {
			f.n.x = 0;
			f.n.y = 0;
			f.n.z = 0;
		}
	}

	level[lev].num_face++;
	level[lev].face.push_back(f);
}

void dxf::Render()
{
	float a[4][2]=
	{
		{0,0},
		{1,0},
		{1,1},
		{0,1}
	};

	for(int lev=0; lev<MAX_LEVEL; lev++)
	{
		if(level[lev].num_face==0)continue;
		if(level[lev].texturing)
		{
			glEnable(GL_TEXTURE_2D);
			glBindTexture(GL_TEXTURE_2D,level[lev].texture);
		}
		else
		{
			glDisable(GL_TEXTURE_2D);
			if( (level[lev].color[0]+level[lev].color[1]+level[lev].color[2])!=0)
			{
				glColor4fv(level[lev].color);
			}
		}
		//glBegin(GL_TRIANGLES );
		//glBegin(GL_TRIANGLE_STRIP );
		for(int i=0; i<level[lev].num_face; i++)
		{
			

		/*	glTexCoord2fv(&a[0][0]);
			glVertex3fv(&level[lev].face[i].v[0].x);

			glTexCoord2fv(&a[1][0]);
			glVertex3fv(&level[lev].face[i].v[1].x);

			glTexCoord2fv(&a[2][0]);
			glVertex3fv(&level[lev].face[i].v[2].x);

			
			glTexCoord2fv(&a[0][0]);
			glVertex3fv(&level[lev].face[i].v[0].x);

			glTexCoord2fv(&a[2][0]);
			glVertex3fv(&level[lev].face[i].v[2].x);

			glTexCoord2fv(&a[3][0]);
			glVertex3fv(&level[lev].face[i].v[3].x);
		*/
			glBegin(GL_TRIANGLE_STRIP );
			glNormal3fv(&level[lev].face[i].n.x);

			glTexCoord2fv(&a[1][0]);
			glVertex3fv(&level[lev].face[i].v[1].x);

			glTexCoord2fv(&a[0][0]);
			glVertex3fv(&level[lev].face[i].v[0].x);

			glTexCoord2fv(&a[2][0]);
			glVertex3fv(&level[lev].face[i].v[2].x);

			glTexCoord2fv(&a[3][0]);
			glVertex3fv(&level[lev].face[i].v[3].x);

			glEnd();
		}
	//	glEnd();
	}
	glEnable(GL_TEXTURE_2D);
}

void dxf::Render_line()
{
	glDisable(GL_TEXTURE_2D);

	for(int lev=0; lev<MAX_LEVEL; lev++)
	{
		if(level[lev].num_face==0)continue;
/*		if(level[lev].texturing)
		{
			
			glBindTexture(GL_TEXDTURE_2D,level[lev].texture);
		}
		else
		{
			
			if( (level[lev].color[0]+level[lev].color[1]+level[lev].color[2])!=0)
			{
				glColor4fv(level[lev].color);
			}
		}
*/
		for(int i=0; i<level[lev].num_face; i++)
		{
		glBegin(GL_LINE_LOOP  );
			glVertex3fv(&level[lev].face[i].v[0].x);
			glVertex3fv(&level[lev].face[i].v[1].x);
			glVertex3fv(&level[lev].face[i].v[2].x);
		glEnd();
		glBegin(GL_LINE_LOOP  );
			glVertex3fv(&level[lev].face[i].v[0].x);
			glVertex3fv(&level[lev].face[i].v[2].x);
			glVertex3fv(&level[lev].face[i].v[3].x);
		glEnd();
		}
	}
	glEnable(GL_TEXTURE_2D);
}

void dxf::Render_visible_line(float dx,float dy,float dz)
{
/*	float length;

	length = (float) sqrt(dx * dx + dy * dy + dz * dz);
	if (length != 0) {
		dx /= length;
		dy /= length;
		dz /= length;
	} else {
		dx = 0;
		dy = 0;
		dz = 0;
	}
*/
	glDisable(GL_TEXTURE_2D);
	glColor3f(0.0f,0,0);

	for(int lev=0; lev<MAX_LEVEL; lev++)
	{
		if(level[lev].num_face==0)continue;
		for(int i=0; i<level[lev].num_face; i++)
		{
			
			glBegin(GL_TRIANGLE_STRIP );

			glVertex3fv(&level[lev].face[i].v[1].x);
			glVertex3fv(&level[lev].face[i].v[0].x);
			glVertex3fv(&level[lev].face[i].v[2].x);
			glVertex3fv(&level[lev].face[i].v[3].x);

			glEnd();
		}
	}
	glEnable(GL_TEXTURE_2D);
	glColor3f(1,1,1);
	glPushMatrix();
	glTranslatef(dx,-dz,dy);
	Render_line();
	glPopMatrix();
}

void dxf::Render_normals(void)
{
	XYZ		a;
	glDisable(GL_TEXTURE_2D);
	glColor3f(1,1,0);
	glBegin(GL_LINES  );
	for(int lev=0; lev<MAX_LEVEL; lev++)
	{
		if(level[lev].num_face==0)continue;
		for(int i=0; i<level[lev].num_face; i++)
		{
			a.x = 0.5f*(level[lev].face[i].v[0].x+level[lev].face[i].v[2].x);
			a.y = 0.5f*(level[lev].face[i].v[0].y+level[lev].face[i].v[2].y);
			a.z = 0.5f*(level[lev].face[i].v[0].z+level[lev].face[i].v[2].z);
			
			glVertex3fv(&a.x);
			glVertex3f(a.x+0.3f*level[lev].face[i].n.x,a.y+0.3f*level[lev].face[i].n.y,a.z+0.3f*level[lev].face[i].n.z);
		}
	}
	glEnd();
	glEnable(GL_TEXTURE_2D);
}

XYZ dxf::CheckCollision(XYZ *vp, float m_radius)
{
	CVector3 m_vPosition = *vp;
	for(int lev=0; lev<MAX_LEVEL; lev++)
	{
		if(level[lev].num_face==0)continue;
		for(int i=0; i<level[lev].num_face; i++)
		{
			// Store of the current triangle we testing
			CVector3 vTriangle[4] = { level[lev].face[i].v[0], level[lev].face[i].v[1], level[lev].face[i].v[2], level[lev].face[i].v[3] };

			// 1) STEP ONE - Finding the sphere's classification
		
			// We want the normal to the current polygon being checked
			CVector3 vNormal = level[lev].face[i].n;	//Normal(vTriangle);

			// This will store the distance our sphere is from the plane
			float distance = 0.0f;

			// This is where we determine if the sphere is in FRONT, BEHIND, or INTERSECTS the plane
			int classification = ClassifySphere(m_vPosition, vNormal, vTriangle[0], m_radius, distance);

			// If the sphere intersects the polygon's plane, then we need to check further
			if(classification == INTERSECTS) 
			{
				// 2) STEP TWO - Finding the psuedo intersection point on the plane

				// Now we want to project the sphere's center onto the triangle's plane
				CVector3 vOffset = vNormal * distance;

				// Once we have the offset to the plane, we just subtract it from the center
				// of the sphere.  "vIntersection" is now a point that lies on the plane of the triangle.
				CVector3 vIntersection = m_vPosition - vOffset;

				// 3) STEP THREE - Check if the intersection point is inside the triangles perimeter

				// We first check if our intersection point is inside the triangle, if not,
				// the algorithm goes to step 4 where we check the sphere again the polygon's edges.

				// We do one thing different in the parameters for EdgeSphereCollision though.
				// Since we have a bulky sphere for our camera, it makes it so that we have to 
				// go an extra distance to pass around a corner. This is because the edges of 
				// the polygons are colliding with our peripheral view (the sides of the sphere).  
				// So it looks likes we should be able to go forward, but we are stuck and considered 
				// to be colliding.  To fix this, we just pass in the radius / 2.  Remember, this
				// is only for the check of the polygon's edges.  It just makes it look a bit more
				// realistic when colliding around corners.  Ideally, if we were using bounding box 
				// collision, cylinder or ellipses, this wouldn't really be a problem.

				if(InsidePolygon(vIntersection, vTriangle, 4) ||
				   EdgeSphereCollision(m_vPosition, vTriangle, 4, m_radius / 2))
				{
					// If we get here, we have collided!  To handle the collision detection
					// all it takes is to find how far we need to push the sphere back.
					// GetCollisionOffset() returns us that offset according to the normal,
					// radius, and current distance the center of the sphere is from the plane.
					vOffset = GetCollisionOffset(vNormal, m_radius, distance);

					// Now that we have the offset, we want to ADD it to the position and
					// view vector in our camera.  This pushes us back off of the plane.  We
					// don't see this happening because we check collision before we render
					// the scene.
					m_vPosition = m_vPosition + vOffset;
				}
			}
		}
	}
	vp->x = m_vPosition.x;
	vp->y = m_vPosition.y;
	vp->z = m_vPosition.z;
	return *vp;
}
