//////////////////////////////////////////////////////////////////////
// scene.cpp: implementation of the scene class.
//
//////////////////////////////////////////////////////////////////////

#include "scene.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

scene::scene()
{
//	int j;
	//////////////////////////////////////
	// smerniky na instancie na triedy nastavim na NULL, aby som ich potom nemazal
	font0 = NULL;
//	obj = NULL;
	obj_dxf = NULL;
	c = NULL;
	//////////////////////////////////////
	// textury
	textura = 0;
	//////////////////////////////////////
	// prepinace
	svetlo=0; texturovanie=1; ciary=0; anim=1; normals=0; kolizia=1;

	polomer_gule = 0.25f;
	fps = 200;							// v pripade ze nieco zavisy od fps
	//////////////////////////////////////
	// nacitanie textur
//	if( !LoadTexture("A.bmp",&textura) ) {error = 1;return;}
	//////////////////////////////////////
	// vytvarame instancie pouzivanych tried
	font0 = new Font("data/font.bmp",&error);		// vytvorenie fontu
	c = new Camera;
//	obj = new C3ds("data/model/1.3ds");
	obj_dxf = new dxf("data/1.dxf");
	if(error)return;

	InitGL();									// nastavenie z-buffra,svetla,...

	//ShowCursor(0);
}

scene::~scene()
{
//	int i;
	//////////////////////////////////////
	// mazeme instancie tried
	if(font0!=NULL)delete font0;
	if(c!=NULL)delete c;
//	if(obj!=NULL)delete obj;
	if(obj_dxf!=NULL)delete obj_dxf;

	//////////////////////////////////////
	// mazeme textury
//	glDeleteTextures( 1, &strela_dopad);
	KillGL();
	ShowCursor(1);
}

void scene::InitGL(void)
{
	if(!fullscreen)
	{
		RECT		WindowRect;					// miesto pre velkost okna
		WindowRect.left=(long)0;
		WindowRect.top=(long)0;
		GetClientRect(hWnd,&WindowRect);				//zistenie rozmerov uzivatelskej casti okna
		ReSizeGLScene(WindowRect.right,WindowRect.bottom);	//nastavenie perspektivy
	}
	else ReSizeGLScene(screen_x, screen_y);	//definovana v tomto subore

	glEnable(GL_TEXTURE_2D);		// Povolenie zobrazovanie textr
	glShadeModel(GL_SMOOTH);		/*nastavuje tienovanie
	GL_SMOOTH - objekty su tienovane t.j. prechody medzi farbami bodov su plinule (gouradovo (s)tienovanie)
	GL_FLAT   - objekty nie su tienovane ziadne plinule prechody */

	glClearColor(0.0f, 0.0f, 0.0f, 0.0f); //specifikuje hodnoty na cistenie pomocou glClear par.: red, green, blue, alpha (cierny podklad)
	glClearDepth(1.0f);  //specifikuje hodnoty na cistenie pomocou glClear par.: depth (hlbka)
	
	/* ZAPNUTIE HLBKOVEHO TESTU */
	glEnable(GL_DEPTH_TEST);		// zapne hbkov test
	glDepthFunc(GL_LEQUAL);			// typ hbkovho testu
	glHint(GL_PERSPECTIVE_CORRECTION_HINT,GL_NICEST);	// relnejie perspektvne vpoty

	GLfloat LightAmbient[]	=	{ 0.3f, 0.3f, 0.3f, 1.0f };		//svetlo ktore osvetluje zo vsetkych stran rovnako (okolite svetlo)
	GLfloat LightDiffuse[]	=	{ 1.0f, 1.0f, 1.0f, 1.0f };		//smerove, alebo bodove svetlo - svetlo svieti z pozicie zadanej pomocou premennej LightPosition
	GLfloat LightPosition[4]=	{ 0.0f, 0.0f, 1.0f, 0.0f };		//smer difuzneho svetla - ak je 4 zlozka 0 - smerove svetlo, ak nie je 0 potom s jedna o bodove svetlo so suradnicami x,y,z
	
	glLightModelfv ( GL_LIGHT_MODEL_AMBIENT, LightAmbient );	// nastavenie okoliteho (Ambient) svetla
	glLightfv ( GL_LIGHT0, GL_DIFFUSE, LightDiffuse );			// nastavenie difuzneho svetla
	glLightfv ( GL_LIGHT0, GL_POSITION, LightPosition  );		// pozicia difuzneho svetla
	glEnable  ( GL_LIGHT0 );									// aktivovanie svetla 0
	
//	GLfloat mat_diffuse[]	= { 1.0f, 1.0f, 1.0f, 1.0f };
//	GLfloat mat_specular[]	= { 0.9f, 0.9f, 0.9f, 1.0f };
//	GLfloat mat_shininess[] = { 128.0f };

//	glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE , mat_diffuse);
//	glMaterialfv(GL_FRONT, GL_SPECULAR, mat_specular);
//	glMaterialfv(GL_FRONT, GL_SHININESS, mat_shininess);

	glColor3f(1.0f,1.0f,1.0f);				// biela farba	
}

void scene::KillGL()
{
}


void scene::Kurzor(void)			// zisti poziciu mysi a zobrazy kurzor
{
/*	GetCursorPos(&MouseBod);		//nacitanie pozicie mysi
	glBegin(GL_LINES);
		glVertex2i(MouseBod.x+velkost_kurzoru+1,screen_y-1-MouseBod.y);
		glVertex2i(MouseBod.x-velkost_kurzoru+1,screen_y-1-MouseBod.y);
		glVertex2i(MouseBod.x+1,screen_y-1-MouseBod.y+velkost_kurzoru);
		glVertex2i(MouseBod.x+1,screen_y-1-MouseBod.y-velkost_kurzoru);
	glEnd();
*/
	glBegin(GL_LINES);
		glVertex2i(mouse_x+velkost_kurzoru+1,mouse_y);
		glVertex2i(mouse_x-velkost_kurzoru+1,mouse_y);
		glVertex2i(mouse_x+1,mouse_y+velkost_kurzoru);
		glVertex2i(mouse_x+1,mouse_y-velkost_kurzoru);
	glEnd();
}

void scene::ReSizeGLScene(int width, int height)
{
	sirka = width;
	vyska = height;
	ReSizeGLScene_2D(width, height);
}

void scene::ReSizeGLScene_3D(int width, int height)		// funkcia pre zmenu velkosti okna
{										// vola sa v pripade zmeny velkosti okna, zmenu z(na) fullscreen
	if (height==0) height=1;
	glViewport(0,0,width,height);		// Viewport (pohlad)
	glMatrixMode(GL_PROJECTION);		// projekcia
	glLoadIdentity();					// Reset pohladu - nacita jednotkovu maticu
	gluPerspective(uhol_kamery,(GLfloat)width/(GLfloat)height,blizka_orezavacia_rovina,vzdialena_orezavacia_rovina);
	/* gluPerspective - nastavuje perspektivu kamery, ako bude vypadat priestor z pohladu kamery.
	1. parameter urcuje zorn uhol kamery. 2.param. - gldAspect je pomer vky a rky zobrazovanej plochy.
	3. par. udava vzdialenost od ktorej je vidiet vykreslovane objekty
	4. par. udava vzdialenost do ktorej je vidiet vykreslovane objekty */
	glMatrixMode(GL_MODELVIEW);			// Modelview
	glLoadIdentity();					// Reset The Modelview Matrix
}

void scene::ReSizeGLScene_2D(int width, int height)		// funkcia pre zmenu velkosti okna
{
	if (height==0) height=1;
	glViewport(0,0,width,height);		// Viewport (pohlad)
	glMatrixMode(GL_PROJECTION);		// projekcia
	glLoadIdentity();					// Reset pohladu - nacita jednotkovu maticu
	glOrtho(0,screen_x,0,screen_y,-1,1);	// nastavuje standardne pravouhle premietanie
	glMatrixMode(GL_MODELVIEW);			// Modelview
	glLoadIdentity();					// Reset The Modelview Matrix
}

void scene::Prepni_do_3D(void)			// rychle prepnutie do 3D
{
	glEnable(GL_DEPTH_TEST );

	glMatrixMode(GL_PROJECTION);		// projekcia
	glLoadIdentity();					// Reset pohladu - nacita jednotkovu maticu
	gluPerspective(uhol_kamery,(float)sirka/(float)vyska,blizka_orezavacia_rovina,vzdialena_orezavacia_rovina);
	/* gluPerspective - nastavuje perspektivu kamery, ako bude vypadat priestor z pohladu kamery.
	1. parameter urcuje zorn uhol kamery. 2.param. - gldAspect je pomer vky a rky zobrazovanej plochy.
	3. par. udava vzdialenost od ktorej je vidiet vykreslovane objekty
	4. par. udava vzdialenost do ktorej je vidiet vykreslovane objekty */
	glMatrixMode(GL_MODELVIEW);			// Modelview
	glLoadIdentity();
}

void scene::Prepni_do_2D(void)			// rychle prepnutie do 2D
{
	if(svetlo)glDisable(GL_LIGHTING);					// vypne svetlo
	if(ciary)glPolygonMode(GL_FRONT_AND_BACK,GL_FILL);	// vypne ciarovy rezim
	if(!texturovanie)glEnable(GL_TEXTURE_2D);			// zapne texturovanie
	glDisable(GL_DEPTH_TEST );

	glMatrixMode(GL_PROJECTION);		// projekcia
	glLoadIdentity();					// Reset pohladu - nacita jednotkovu maticu
	glOrtho(0,screen_x,0,screen_y,-1,1);// nastavuje standardne pravouhle premietanie
	glMatrixMode(GL_MODELVIEW);			// Modelview
	glLoadIdentity();					// Reset The Modelview Matrix
}

