//////////////////////////////////////////////////////////////////////
// Naprogramoval: Marek Mizanin, mizanin@szm.sk, mizanin@stonline.sk
//                www.mizanin.szm.sk, ICQ: 158283635
//
//
//////////////////////////////////////////////////////////////////////
//	Pouzivane klavesy:
//	
//	H - help
//
//////////////////////////////////////////////////////////////////////
//
// scene.h: interface for the scene class.
//
//////////////////////////////////////////////////////////////////////

#ifndef _SCENE_H
#define _SCENE_H

#include "init.h"				// zakladne nastavenia a zakladne hlavickove subory
								// vazby na init.cpp

#include <stdlib.h>				// standardna kniznica
#include <stdarg.h>				// --
#include <stdio.h>				// --
#include <math.h>				// matematicka kniznica
#include "load_texture.h"
#include "Timer.h"				// trieda Timer pre pracu z casovacom
#include "bitmap_Font.h"		// trieda pre vypisovanie textu pomocou bitmapoveho fontu
#include "camera.h"				// trieda pre transformacie
//#include "3ds1.h"
#include "dxf.h"
#include "Util.h"

#ifndef PI180
#define PI180	0.0174532925199432957692369076848861f	// pi / 180
#endif
	
class scene
{
	Font	*font0;
	Timer	timer0;
	Camera	*c;
//	C3ds	*obj;
	dxf		*obj_dxf;

	unsigned int textura;	
	float	fps,polomer_gule;
	uFPS_counter fps_counter;
private:
	char	text[30];					// text pre konverziu z float na text
	bool	svetlo,texturovanie,ciary,anim,normals,kolizia;
	
	POINT MouseBod;
	int mouse_x,mouse_y,sirka,vyska;
public:
	void ReSizeGLScene( int width, int height);
	void ReSizeGLScene_2D(int width, int height);	// funkcia pro zmenu velkosti okna
	void ReSizeGLScene_3D(int width, int height);	// funkcia pro zmenu velkosti okna
	void DrawGLScene(void);
	scene();
	~scene();
private:
	void KillGL(void);
	void InitGL(void);
	void Prepni_do_2D(void);
	void Prepni_do_3D(void);
	void Kurzor(void);			// zisti poziciu mysi a zobrazy kurzor
};

#define velkost_kurzoru 5

#endif
